import 'package:example/vivanta.dart';
import 'package:flutter/material.dart';
import 'package:vivanta_connect_flutter/helpers/vivanta_sync.dart';
import 'package:vivanta_connect_flutter/vivanta_connect_flutter.dart';

class Home extends StatelessWidget {
  Home({Key? key}) : super(key: key) {
    final sync = VivantaSync(
      apiKey: Vivanta.apiKey,
      customerId: Vivanta.customerId,
      externalUserId: Vivanta.externalUserId,
    );
    sync.executeAll();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Vivanta Connect Example'),
      ),
      body: Container(
        width: MediaQuery.of(context).size.width,
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            TextButton(
              onPressed: () {
                Navigator.of(context).push(
                  MaterialPageRoute(
                    builder: (context) => VivantaConnectFlutter(
                      apiKey: Vivanta.apiKey,
                      customerId: Vivanta.customerId,
                      externalUserId: Vivanta.externalUserId,
                      companyId: Vivanta.companyId,
                    ),
                  ),
                );
              },
              child: Text(
                'Start Vivanta Connect',
                textAlign: TextAlign.center,
              ),
            ),
          ],
        ),
      ),
    );
  }
}
