import 'package:hive_flutter/hive_flutter.dart';
import 'package:vivanta_connect_flutter/models/apple_health_element.dart';

class Database {
  Box<AppleHealthElement>? appleHealthElementBox;

  init() async {
    await Hive.initFlutter();
    if (!Hive.isAdapterRegistered(0)) {
      Hive.registerAdapter(AppleHealthElementAdapter());
    }
    appleHealthElementBox =
        await Hive.openBox<AppleHealthElement>('apple_heealth_elements');
  }

  Future<AppleHealthElement?> getAppleHealthElement(String id) async {
    try {
      return appleHealthElementBox!.values
          .firstWhere((element) => element.id == id);
    } catch (_) {}
    return null;
  }

  Future<int> saveAppleHealthElement(AppleHealthElement element) {
    return appleHealthElementBox!.add(element);
  }

  Future<void> updateAppleHealthElement(AppleHealthElement element) {
    return appleHealthElementBox!.put(element.key, element);
  }

  List<AppleHealthElement> getUnsyncedAppleHealthElements() {
    return appleHealthElementBox!.values
        .where((element) => element.synced == false)
        .toList();
  }

  void deleteAppleHealthElement(AppleHealthElement element) {
    element.delete();
  }
}
