import 'package:health/health.dart';

class Healthkit {
  HealthFactory health = HealthFactory(useHealthConnectIfAvailable: true);

  Future<bool> requestAuthorization(List<HealthDataType> types) async {
    return health.requestAuthorization(types);
  }

  Future<bool> authorizationStatus(HealthDataType dataType) async {
    return health.isDataTypeAvailable(dataType);
  }

  Future<List<HealthDataPoint>> getDataPoint(
    List<HealthDataType> types,
    DateTime start,
    DateTime end,
  ) async {
    List<HealthDataPoint> healthData = await health.getHealthDataFromTypes(
      start,
      end,
      types,
    );

    return healthData;
  }

  Future<int> getTotalSteps(DateTime start, DateTime end) async {
    int? steps = await health.getTotalStepsInInterval(start, end);
    return steps ?? 0;
  }
}
