import 'package:flutter_secure_storage/flutter_secure_storage.dart';

class Preferences {
  final storage = const FlutterSecureStorage();

  static const _token = 'token';
  Future<String> getToken() async {
    return await storage.read(key: _token) ?? '';
  }

  Future<void> setToken(String value) async {
    await storage.write(key: _token, value: value);
  }

  static const _apiKey = 'apiKey';
  Future<String> getApiKey() async {
    return await storage.read(key: _apiKey) ?? '';
  }

  Future<void> setApiKey(String value) async {
    await storage.write(key: _apiKey, value: value);
  }

  static const _customerId = 'customerId';
  Future<String> getCustomerId() async {
    return await storage.read(key: _customerId) ?? '';
  }

  Future<void> setCustomerId(String value) async {
    await storage.write(key: _customerId, value: value);
  }

  static const _externalUserId = 'externalUserId';
  Future<String> getExternalUserId() async {
    return await storage.read(key: _externalUserId) ?? '';
  }

  Future<void> setExternalUserId(String value) async {
    await storage.write(key: _externalUserId, value: value);
  }

  static const _lastSync = 'lastSync';
  Future<int> getLastSync() async {
    final lastSync = await storage.read(key: _lastSync) ?? '0';
    return int.parse(lastSync);
  }

  Future<void> setLastSync(int value) async {
    await storage.write(key: _lastSync, value: value.toString());
  }

  static const _appleHealthAccessGranted = 'appleHealthAccessGranted';
  Future<bool> getAppleHealthAccessGranted() async {
    final appleHealthAccessGranted =
        await storage.read(key: _appleHealthAccessGranted) ?? false;
    return appleHealthAccessGranted.toString() == "true";
  }

  Future<void> setAppleHealthAccessGranted(bool value) async {
    await storage.write(
        key: _appleHealthAccessGranted, value: value.toString());
  }

  static const _appleHealthAccessGrantedDate = 'appleHealthAccessGrantedDate';
  Future<DateTime> getAppleHealthAccessGrantedDate() async {
    final appleHealthAccessGrantedDate =
        await storage.read(key: _appleHealthAccessGrantedDate) ?? '';
    try {
      return DateTime.parse(appleHealthAccessGrantedDate.toString());
    } catch (e) {
      return DateTime.now();
    }
  }

  Future<void> setAppleHealthAccessGrantedDate(DateTime value) async {
    await storage.write(
      key: _appleHealthAccessGrantedDate,
      value: value.toIso8601String(),
    );
  }

  static const _appleHealthSyncDate = 'appleHealthSyncDate';
  Future<DateTime> getAppleHealthSyncDate() async {
    final appleHealthSyncDate =
        await storage.read(key: _appleHealthSyncDate) ?? '';
    try {
      return DateTime.parse(appleHealthSyncDate.toString());
    } catch (e) {
      return getAppleHealthAccessGrantedDate();
    }
  }

  Future<void> setAppleHealthSyncDate(DateTime value) async {
    await storage.write(
      key: _appleHealthSyncDate,
      value: value.toIso8601String(),
    );
  }
}
